
;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_Control_ID		db	0
.V_App_Control_Addr		dw	0
.V_App_Form_ID			db	0
.V_App_Form_Addr		dw 	0
.V_App_Action_ID		db	0
.V_App_OS_Form			db  0

.AppPrz:
       ld    a,(AppPrzN)
       ld    (Form1+WinDatPrz),a
       db    #dd:ld l,a
       ld    a,(DskPrzN)
       db    #dd:ld h,a
       ld    a,(AppBnkNum)
       ld    h,a
       ld    l,MSC_DSK_WINOPN
       ld    (AppMsgB),hl
       ld    hl,Form1
       ld    (AppMsgB+2),hl
       ld    iy,AppMsgB
       rst   #10
.App_Prz1:
       call  App_Wait_Message
       jr    nc,App_Prz1
       ld    a,(DskPrzN)
       db    #dd:cp h
       jr    nz,App_Prz1
       ld    a,(AppMsgB)
       cp    MSR_DSK_WOPNER
       jp    z,App_End
       cp    MSR_DSK_WOPNOK
       jr    nz,App_Prz1
       ld    a,(AppMsgB+4)
       ld    (AppWin),a
.App_Control_Loop:
       call   App_Wait_Message
       jr     nc,App_Control_Loop0
       cp     MSR_DSK_WCLICK
       jr     nz,App_Control_Loop0
       ld     a,(AppMsgB+2)
       cp     DSK_ACT_CLOSE
       jp     z,App_End
       cp     DSK_ACT_MENU
       jp     z,App_Menu
       cp     DSK_ACT_CONTENT
       jp     z,App_Content
.App_Control_Loop0:
       jr     App_Control_Loop

.App_Menu:
       ld     a,(AppMsgB+9)
       cp     #0
       jp     z,App_Control_Loop
       ld     hl,(AppMsgB+8)
       ld     (App_Call_Set2+1),hl
.App_Call_Set2:
       call   0
       jp     App_Control_Loop

.App_Content:
	call	App_Store_Message
	ld		hl,(V_App_Control_Addr)
	ld		de,2
	add		hl,de
	ld		a,(hl)						;**** Get type
	cp		20
	jp		z,Check_Tabs

.App_Content2:
	ld		hl,(V_App_Control_Addr)
	ld		de,14
	add		hl,de
	call	App_CallUserEvent
	jp		App_Control_Loop

;**** Calls a User Event if it exists
;**** IN HL = Location of the address of the event
.App_CallUserEvent:
	ld		e,(hl)						;**** Get type
	inc		hl
	ld		a,(hl)
	cp		0
	jp		z,App_Control_Loop
	push	ix
	push	iy
	ld		(App_Content3+2),a
	ld		a,e
	ld		(App_Content3+1),a
	ld		a,(V_App_Action_ID)
.App_Content3:	
	call	0
	pop		iy
	pop		ix
	ret
	
.Check_Tabs:
	ld		hl,(V_App_Control_Addr)
	ld		de,#4
	call 	Sys_HL_Addr
;**** Lets update OldValue	
	ld		de,2				;Point to Halue
	add		hl,de				;
	ld		a,(hl)				;a=Value
	ld		de,-4				;Point to OldValue
	add		hl,de				;
	cp		(hl)
	jp		z,YakkiMoron		;Skip cos its the Same
	ld		(hl),a				;Old Value updated
;****
	inc		hl					;Point to VisGroup start
	ld		c,(hl)				;c=Visgroup start
	add		c					;a=Visgroup the be Shown ( Value + VisGroup Start)
	inc		hl					;Point to number of Tabs
	ld		b,(hl)				;B= Number of Tabs
.MatadorShoes
	cp		c
	jr		z,ShowThisTab
.DontShowTab
	call	Sys_Visible_Off
	jr		Yukkie
.ShowThisTab
	call	Sys_Visible_On
.Yukkie
	inc		c
	djnz	MatadorShoes
	ld		hl,Sys_DisplayData
	ld		a,(V_App_Control_ID)
	sub		1
	ld		e,a
	ld		d,0
	add		hl,de
	ld		a,1
	ld		(hl),a
	inc		hl
	ld		(hl),a
	ld		hl,Sys_DisplayData
	ld		b,28
	ld		c,0
.GregorysGirl
	ld		a,(hl)
	cp		0
	jr		z,Gregorys2Girls
	ld		a,c

	push	bc
	push	hl
	Call	Sys_Redraw_Object
	pop		hl
	pop		bc
	ld		a,0
	ld		(hl),a
.Gregorys2Girls
	inc		c
	inc		hl
	djnz	GregorysGirl
.Yakkimoron
	jp		App_Content2

.App_Store_Message:
	ld		a,(AppMsgB+0)
	ld		(V_App_Action_ID),a
	ld		a,(AppMsgB+1)
	ld		(V_App_OS_Form),a
	ld		a,(AppMsgB+8)
	ld		(V_App_Control_ID),a
	ld		b,a
	ld		a,(AppMsgB+9)
	ld		(V_App_Form_ID),a
	ld		e,a
	ld		d,0
	ld		hl,AppFormLists
	add		hl,de
	add		hl,de
	ld		e,(hl)
	inc		hl
	ld		d,(hl)
	ld		(V_App_Form_Addr),de
	ld		l,b
	ld		h,0
	add		hl,hl					;**** Times 2
	add		hl,hl					;**** Times 4
	add		hl,hl					;**** Times 8
	add		hl,hl					;**** Times 16
	add		hl,de		
	ld		(V_App_Control_Addr),hl
	ret

.App_Wait_Message:
        rst   #30
        ld    a,(AppPrzN)
        db    #dd:ld l,a
        db    #dd:ld h,-1
        ld    iy,AppMsgB
        rst   #18
        Or    a
        db    #dd:dec l
        ret   nz
        ld    a,(AppMsgB+0)
        Or    a
        jr    z,App_End
        scf
        ret
.App_End:
        ld    a,(AppPrzN)
        db    #dd:ld l,a
        ld    a,(SysPrzN)
        db    #dd:ld h,a
        ld    a,(AppCodBeg+PrgPstNum)
        ld    h,a
        ld    l,MSC_SYS_PRGEND
        ld    (AppMsgB),hl
        ld    iy,AppMsgB
        rst   #10
.App_End0:
        rst   #30
        jr    App_End0

.Sys_Temp1:		dw	0

Sys_DisplayData:
		ds	256

;**** Basically Makes HL the contents of HL+DE
.Sys_HL_Addr
	add		hl,de
	ld		e,(hl)
	inc		hl
	ld		d,(hl)
	ex		de,hl
	ret
;**** System Routine ****
.Sys_Visible_On
	push	af
	push	bc
	push	de
	push	hl
;**** In 	C = Visability Group
;			B = Number of times To Loop
	ld		hl,(V_App_Form_Addr)
	ld		de,-16
	add		hl,de
	ld		b,(hl)
	ld		de,17
	add		hl,de
	ld		de,Sys_DisplayData
BwScangMuppet:
	ld		a,(hl)
	inc		hl
	And		%111111
	cp		c
	jr		nz,PhilCoolTugBoat
	ld		a,(hl)
	And		%111111
	ld		(hl),a
	ld		a,1
	ld		(de),a
PhilCoolTugBoat:
	inc		de
	push	de
	ld		de,15
	add		hl,de
	pop		de
	djnz	BwScangMuppet
	pop		hl
	pop		de
	pop		bc
	pop		af	
	ret

;**** System Routine ****
.Sys_Visible_Off
	push	af
	push	bc
	push	de
	push	hl
;**** In 	C = Visability Group
;			B = Number of times To Loop
	ld		hl,(V_App_Form_Addr)
	ld		de,-16
	add		hl,de
	ld		b,(hl)
	ld		de,17
	add		hl,de
	ld		de,15
BwScangMuppet2:
	ld		a,(hl)
	inc		hl
	And		%111111
	cp		c
	jr		nz,PhilCoolTugBoat2
	ld		a,(hl)
	Or		%11000000
	ld		(hl),a
PhilCoolTugBoat2:
	add		hl,de
	djnz	BwScangMuppet2
	pop		hl
	pop		de
	pop		bc
	pop		af
	ret

;**** System Routines ****
.Sys_Set_Visible:
;**** a = 0 \ Visible 1 \ Invisible
;**** b = Object
;**** c = Form
	And		%00000001
	rrca
	ld		e,c							;* e = form number
	ld		d,0							;* d = 0
	ld		hl,AppFormLists				;* Start of each Forms Data
	add		hl,de						;* HL = HL + (DE*2)
	add		hl,de						;
	ld		e,(hl)						;* DE = Address of Form Data
	inc 	hl
	ld		d,(hl)
	ld		(Sys_Temp1),de				;* Store the Base Address Temporarily

	ld		l,b							;* HL = Object
	ld		h,0
	add		hl,hl
	add		hl,hl
	add		hl,hl
	add		hl,hl
	add		hl,de
	inc		hl
	inc		hl							;* HL = Address of Type / Visibility Byte of Object
	ld		c,a
	ld		a,(hl)
	ld		e,a
	And		%01111111
	Or		c
	cp		e
	ret		z
	ld		(hl),a
	ld		a,b
	Call	Sys_Redraw_All
	ret

;**** System Routines ****
.Sys_Redraw_All:
	ld		a,-1
	ld		(AppMsgB+2),a		
	ld		a,MSC_DSK_WINDIN
	ld		(AppMsgB+0),a
	ld		a,(V_App_OS_Form)
	ld		(AppMsgB+1),a
	ld		iy,AppMsgB
	rst 	#10
	ret
;**** System Routines ****
.Sys_Redraw_Object:
	ld		(AppMsgB+2),a		
	ld		a,MSC_DSK_WINDIN
	ld		(AppMsgB+0),a
	ld		a,(V_App_OS_Form)
	ld		(AppMsgB+1),a
	ld		iy,AppMsgB
	rst 	#10
	ret